'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

exports['default'] = createDevTools;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _reactReduxLibComponentsCreateAll = require('react-redux/lib/components/createAll');

var _reactReduxLibComponentsCreateAll2 = _interopRequireDefault(_reactReduxLibComponentsCreateAll);

var _redux = require('redux');

var _devTools = require('./devTools');

function createDevTools(React) {
  var PropTypes = React.PropTypes;
  var Component = React.Component;

  var _createAll = _reactReduxLibComponentsCreateAll2['default'](React);

  var Provider = _createAll.Provider;
  var Connector = _createAll.Connector;

  return (function (_Component) {
    _inherits(DevTools, _Component);

    _createClass(DevTools, null, [{
      key: 'propTypes',
      value: {
        monitor: PropTypes.func.isRequired,
        store: PropTypes.shape({
          devToolsStore: PropTypes.shape({
            dispatch: PropTypes.func.isRequired
          }).isRequired
        }).isRequired
      },
      enumerable: true
    }]);

    function DevTools(props, context) {
      var _this = this;

      _classCallCheck(this, DevTools);

      if (props.store && !props.store.devToolsStore) {
        console.error('Could not find the devTools store inside your store. ' + 'Have you applied devTools() higher-order store?');
      }
      _Component.call(this, props, context);

      this.renderRoot = function () {
        return React.createElement(
          Connector,
          null,
          _this.renderMonitor
        );
      };

      this.renderMonitor = function (_ref) {
        var dispatch = _ref.dispatch;

        var state = _objectWithoutProperties(_ref, ['dispatch']);

        var _props = _this.props;
        var Monitor = _props.monitor;

        var rest = _objectWithoutProperties(_props, ['monitor']);

        return React.createElement(Monitor, _extends({}, state, _redux.bindActionCreators(_devTools.ActionCreators, dispatch), rest));
      };
    }

    DevTools.prototype.render = function render() {
      var devToolsStore = this.props.store.devToolsStore;

      return React.createElement(
        Provider,
        { store: devToolsStore },
        this.renderRoot
      );
    };

    return DevTools;
  })(Component);
}

module.exports = exports['default'];